<?php
/*Chonmage_manager-21.07-1 common.php*/

class chonmage_common {
    protected $config;
    protected $db_obj;
    protected $thumbnails;
    
    private $last_error_text;
    
    function __construct () {
        $this->config = parse_ini_file(dirname(__FILE__)."/config.ini");
        $this->thumbnails = json_decode(file_get_contents(dirname(__FILE__)."/thumbnails.json"), TRUE);
    }
    
    function connect_db () {
        if (!extension_loaded("sqlite3")) {
            $this->print_error("このPHP実行環境にはSQLite3モジュールがインストールされていない、または、SQLite3モジュールが有効化されていません。");
            return FALSE;
        }
        
        $this->db_obj = new SQLite3(dirname(__FILE__)."/".$this->config["data_dir"]."/chonmage.db");
        
        $this->db_obj->busyTimeout(5000);
    }
    
    function disconnect_db () {
        $this->db_obj->close();
    }
    
    function print_error ($error_text) {
        $this->last_error_text = $error_text;
        
        if ($this->config["display_errors"]) {
            print "An error occurred in Chonmage manager : ".$error_text;
        }
    }
    
    function get_last_error_text () {
        return $this->last_error_text;
    }
}