<?php
/*Chonmage_manager-21.07-1 config.php*/
require_once(dirname(__FILE__)."/common.php");

define("CHONMAGE_CONFIG_ORIGINAL",
    array(
            "display_errors" => TRUE,
            
            "data_dir" => "../files",
            
            "image_max_width" => 4096,
            "image_max_height" => 4096,
            
            "hash_algorithm" => ""
        )
    );

class chonmage_config extends chonmage_common {
    function save () {
        $file_h = fopen(dirname(__FILE__)."/config.ini","w");
        
        if ($this->config["display_errors"]) {
            fwrite($file_h,"display_errors=true\n");
        } else {
            fwrite($file_h,"display_errors=false\n");
        }
        fwrite($file_h,"\n");
        
        fwrite($file_h,"data_dir=\"".$this->config["data_dir"]."\"\n");
        fwrite($file_h,"\n");
        
        fwrite($file_h,"image_max_width=".$this->config["image_max_width"]."\n");
        fwrite($file_h,"image_max_height=".$this->config["image_max_height"]."\n");
        fwrite($file_h,"\n");
        
        fwrite($file_h,"hash_algorithm=".$this->config["hash_algorithm"]."\n");
        
        fclose($file_h);
    }
    
    
    function set_config_value($key, $value, $save_now = TRUE) {
        if (!isset($value) || gettype(CHONMAGE_CONFIG_ORIGINAL[$key]) !== gettype($value)) {
            $this->print_error("入力値が誤っています。");
            return FALSE;
        }
        
        $this->config[$key] = $value;
        
        if ($save_now) {
            $this->save();
        }
        
        return TRUE;
    }
    
    
    function reset_config() {
        $this->config = CHONMAGE_CONFIG_ORIGINAL;
        
        $this->save();
    }
    
    
    function setup_db () {
        $this->connect_db();
        
        $sqlite_r1 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'chonmage_files'");
        if($sqlite_r1 == FALSE){
            $this->print_error("テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg());
            return FALSE;
        }
        
        $q_kekka = $sqlite_r1->fetchArray(SQLITE3_ASSOC);
        if (!$q_kekka) {
            $sqlite_r1_2 = $this->db_obj->query("CREATE TABLE `chonmage_files`(`file_id` TEXT NOT NULL PRIMARY KEY, `base_path` TEXT NOT NULL UNIQUE, `file_name` TEXT NOT NULL, `file_format` TEXT, `category` TEXT NOT NULL, `title` TEXT, `description` TEXT, `owner` TEXT NOT NULL, `created` TEXT NOT NULL, `last_updated` TEXT NOT NULL, `file_size` TEXT NOT NULL, `hash` TEXT)");
            if ($sqlite_r1_2 == FALSE) {
                $this->print_error("テーブル chonmage_files の作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_3 = $this->db_obj->query("CREATE INDEX `idx_1` ON `chonmage_files`(`file_name`, `created`)");
            if ($sqlite_r1_3 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_4 = $this->db_obj->query("CREATE INDEX `idx_2` ON `chonmage_files`(`file_format`, `created`)");
            if ($sqlite_r1_4 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_5 = $this->db_obj->query("CREATE INDEX `idx_3` ON `chonmage_files`(`title`, `created`)");
            if ($sqlite_r1_5 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_6 = $this->db_obj->query("CREATE INDEX `idx_4` ON `chonmage_files`(`owner`, `created`)");
            if ($sqlite_r1_6 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_7 = $this->db_obj->query("CREATE INDEX `idx_5` ON `chonmage_files`(`owner`, `last_updated`)");
            if ($sqlite_r1_7 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_8 = $this->db_obj->query("CREATE INDEX `idx_6` ON `chonmage_files`(`created`)");
            if ($sqlite_r1_8 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_9 = $this->db_obj->query("CREATE INDEX `idx_7` ON `chonmage_files`(`last_updated`)");
            if ($sqlite_r1_9 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_10 = $this->db_obj->query("CREATE INDEX `idx_8` ON `chonmage_files`(`file_size`, `created`)");
            if ($sqlite_r1_10 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_11 = $this->db_obj->query("CREATE INDEX `idx_9` ON `chonmage_files`(`hash`)");
            if ($sqlite_r1_11 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_12 = $this->db_obj->query("CREATE INDEX `idx_10` ON `chonmage_files`(`category`, `created`)");
            if ($sqlite_r1_12 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_13 = $this->db_obj->query("CREATE INDEX `idx_11` ON `chonmage_files`(`category`, `last_updated`)");
            if ($sqlite_r1_13 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r1_14 = $this->db_obj->query("CREATE INDEX `idx_12` ON `chonmage_files`(`owner`, `category`)");
            if ($sqlite_r1_14 == FALSE) {
                $this->print_error("テーブル chonmage_files のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
        }
        
        
        $sqlite_r2 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'chonmage_images'");
        if ($sqlite_r2 == FALSE) {
            $this->print_error("テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg());
            return FALSE;
        }
        
        $q_kekka = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        if (!$q_kekka) {
            $sqlite_r2_2 = $this->db_obj->query("CREATE TABLE `chonmage_images`(`file_id` TEXT NOT NULL PRIMARY KEY, `width` INTEGER NOT NULL, `height` INTEGER NOT NULL, `original_file_created` TEXT NOT NULL)");
            if ($sqlite_r2_2 == FALSE) {
                $this->print_error("テーブル chonmage_images の作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r2_3 = $this->db_obj->query("CREATE INDEX `idx_i1` ON `chonmage_images`(`original_file_created`)");
            if ($sqlite_r2_3 == FALSE) {
                $this->print_error("テーブル chonmage_images のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
        }
        
        
        $sqlite_r3 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'chonmage_tags'");
        if ($sqlite_r3 == FALSE) {
            $this->print_error("テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg());
            return FALSE;
        }
        
        $q_kekka = $sqlite_r3->fetchArray(SQLITE3_ASSOC);
        if (!$q_kekka) {
            $sqlite_r3_2 = $this->db_obj->query("CREATE TABLE `chonmage_tags`(`file_id` TEXT NOT NULL, `tag_name` TEXT NOT NULL, `tag_order` INTEGER NOT NULL, PRIMARY KEY(`file_id`,`tag_name`))");
            if ($sqlite_r3_2 == FALSE) {
                $this->print_error("テーブル chonmage_tags の作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r3_3 = $this->db_obj->query("CREATE UNIQUE INDEX `idx_t1` ON `chonmage_tags`(`file_id`, `tag_order`)");
            if ($sqlite_r3_3 == FALSE) {
                $this->print_error("テーブル chonmage_tags のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r3_4 = $this->db_obj->query("CREATE INDEX `idx_t2` ON `chonmage_tags`(`tag_name`, `file_id`)");
            if ($sqlite_r3_4 == FALSE) {
                $this->print_error("テーブル chonmage_tags のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
        }
        
        
        $sqlite_r4 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'chonmage_tags_cache'");
        if ($sqlite_r4 == FALSE) {
            $this->print_error("テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg());
            return FALSE;
        }
        
        $q_kekka = $sqlite_r4->fetchArray(SQLITE3_ASSOC);
        if (!$q_kekka) {
            $sqlite_r4_2 = $this->db_obj->query("CREATE TABLE `chonmage_tags_cache`(`file_id` TEXT NOT NULL, `tag_name` TEXT NOT NULL, `file_name` TEXT NOT NULL, `owner` TEXT NOT NULL, `file_format` TEXT, `category` TEXT NOT NULL, `created` TEXT NOT NULL, `last_updated` TEXT NOT NULL, PRIMARY KEY(`file_id`,`tag_name`))");
            if ($sqlite_r4_2 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache の作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r4_3 = $this->db_obj->query("CREATE INDEX `idx_tc1` ON `chonmage_tags_cache`(`tag_name`, `file_name`)");
            if ($sqlite_r4_3 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r4_4 = $this->db_obj->query("CREATE INDEX `idx_tc2` ON `chonmage_tags_cache`(`tag_name`, `owner`, `created`)");
            if ($sqlite_r4_4 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r4_5 = $this->db_obj->query("CREATE INDEX `idx_tc3` ON `chonmage_tags_cache`(`tag_name`, `file_format`, `created`)");
            if ($sqlite_r4_5 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r4_6 = $this->db_obj->query("CREATE INDEX `idx_tc4` ON `chonmage_tags_cache`(`tag_name`, `created`)");
            if ($sqlite_r4_6 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r4_7 = $this->db_obj->query("CREATE INDEX `idx_tc5` ON `chonmage_tags_cache`(`tag_name`, `last_updated`)");
            if ($sqlite_r4_7 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
            
            $sqlite_r4_8 = $this->db_obj->query("CREATE INDEX `idx_tc6` ON `chonmage_tags_cache`(`tag_name`, `category`, `created`)");
            if ($sqlite_r4_8 == FALSE) {
                $this->print_error("テーブル chonmage_tags_cache のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg());
                return FALSE;
            }
        }
        
        $this->disconnect_db();
        
        return TRUE;
    }
    
    function get_thumbnails () {
        return $this->thumbnails;
    }
    
    function save_thumbnails () {
        file_put_contents(dirname(__FILE__)."/thumbnails.json", json_encode($this->thumbnails));
    }
    
    function add_thumbnail ($thumbnail_array) {
        $this->thumbnails[] = $thumbnail_array;
        
        $this->save_thumbnails();
    }
    
    function delete_thumbnail ($name) {
        for ($cnt = 0; isset($this->thumbnails[$cnt]); $cnt++) {
            if ($this->thumbnails[$cnt]["name"] === $name) {
                array_splice($this->thumbnails, $cnt, 1);
                
                $this->save_thumbnails();
                
                return TRUE;
            }
        }
        
        return FALSE;
    }
}
